Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4670)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4671)
@@ -1405,15 +1407,15 @@
           !$ tn = omp_get_thread_num()
           !$OMP DO
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
+          DO  m = 1, surf_lsm_h(0)%ns
+             i = surf_lsm_h(0)%i(m)
+             j = surf_lsm_h(0)%j(m)
 
              IF ( i >= nxl  .AND.  i <= nxr  .AND.  j >= nys  .AND.  j <= nyn )  THEN
-                sums_l(nzb,93,tn)  = sums_l(nzb,93,tn) + surf_lsm_h%ghf(m)       * rmask(j,i,sr)
-                sums_l(nzb,94,tn)  = sums_l(nzb,94,tn) + surf_lsm_h%qsws_liq(m)  * rmask(j,i,sr)
-                sums_l(nzb,95,tn)  = sums_l(nzb,95,tn) + surf_lsm_h%qsws_soil(m) * rmask(j,i,sr)
-                sums_l(nzb,96,tn)  = sums_l(nzb,96,tn) + surf_lsm_h%qsws_veg(m)  * rmask(j,i,sr)
-                sums_l(nzb,97,tn)  = sums_l(nzb,97,tn) + surf_lsm_h%r_a(m)       * rmask(j,i,sr)
-                sums_l(nzb,98,tn)  = sums_l(nzb,98,tn) + surf_lsm_h%r_s(m)       * rmask(j,i,sr)
+                sums_l(nzb,93,tn)  = sums_l(nzb,93,tn) + surf_lsm_h(0)%ghf(m)       * rmask(j,i,sr)
+                sums_l(nzb,94,tn)  = sums_l(nzb,94,tn) + surf_lsm_h(0)%qsws_liq(m)  * rmask(j,i,sr)
+                sums_l(nzb,95,tn)  = sums_l(nzb,95,tn) + surf_lsm_h(0)%qsws_soil(m) * rmask(j,i,sr)
+                sums_l(nzb,96,tn)  = sums_l(nzb,96,tn) + surf_lsm_h(0)%qsws_veg(m)  * rmask(j,i,sr)
+                sums_l(nzb,97,tn)  = sums_l(nzb,97,tn) + surf_lsm_h(0)%r_a(m)       * rmask(j,i,sr)
+                sums_l(nzb,98,tn)  = sums_l(nzb,98,tn) + surf_lsm_h(0)%r_s(m)       * rmask(j,i,sr)
              ENDIF
           ENDDO
@@ -1424,14 +1426,14 @@
           !$ tn = omp_get_thread_num()
           !$OMP DO
-          DO  m = 1, surf_lsm_h%ns
-
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
+          DO  m = 1, surf_lsm_h(0)%ns
+
+             i = surf_lsm_h(0)%i(m)
+             j = surf_lsm_h(0)%j(m)
 
              IF ( i >= nxl  .AND.  i <= nxr  .AND.  j >= nys  .AND.  j <= nyn )  THEN
 
                 DO  k = nzb_soil, nzt_soil
-                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil_h%var_2d(k,m) * rmask(j,i,sr)
-                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil_h%var_2d(k,m) * rmask(j,i,sr)
+                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil_h(0)%var_2d(k,m) * rmask(j,i,sr)
+                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil_h(0)%var_2d(k,m) * rmask(j,i,sr)
                 ENDDO
              ENDIF
Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4646 2020-08-24 16:02:40Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -801,26 +804,28 @@
 !-- Horizontal facades
     buildings(:)%num_facades_per_building_h_l = 0
-    DO  m = 1, surf_usm_h%ns
-!
-!--    For the current facade element determine corresponding building index.
-!--    First, obtain j,j,k indices of the building. Please note the offset between facade/surface
-!--    element and building location (for horizontal surface elements the horizontal offsets are
-!--    zero).
-       i = surf_usm_h%i(m) + surf_usm_h%ioff
-       j = surf_usm_h%j(m) + surf_usm_h%joff
-       k = surf_usm_h%k(m) + surf_usm_h%koff
-!
-!--    Determine building index and check whether building is on PE.
-       nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ), DIM=1 )
-
-       IF ( buildings(nb)%on_pe )  THEN
-!
-!--       Count number of facade elements at each height level.
-          buildings(nb)%num_facade_h(k) = buildings(nb)%num_facade_h(k) + 1
-!
-!--       Moreover, sum up number of local facade elements per building.
-          buildings(nb)%num_facades_per_building_h_l =                                             &
+    DO  l = 0, 1
+       DO  m = 1, surf_usm_h(l)%ns
+!
+!--       For the current facade element determine corresponding building index.
+!--       First, obtain j,j,k indices of the building. Please note the offset between facade/surface
+!--       element and building location (for horizontal surface elements the horizontal offsets are
+!--       zero).
+          i = surf_usm_h(l)%i(m) + surf_usm_h(l)%ioff
+          j = surf_usm_h(l)%j(m) + surf_usm_h(l)%joff
+          k = surf_usm_h(l)%k(m) + surf_usm_h(l)%koff
+!
+!--       Determine building index and check whether building is on PE.
+          nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ), DIM=1 )
+
+          IF ( buildings(nb)%on_pe )  THEN
+!
+!--          Count number of facade elements at each height level.
+             buildings(nb)%num_facade_h(k) = buildings(nb)%num_facade_h(k) + 1
+!
+!--          Moreover, sum up number of local facade elements per building.
+             buildings(nb)%num_facades_per_building_h_l =                                             &
                                                       buildings(nb)%num_facades_per_building_h_l + 1
-       ENDIF
+          ENDIF
+       ENDDO
     ENDDO
 !
@@ -944,14 +949,16 @@
     n_fa = 1
 
-    DO  m = 1, surf_usm_h%ns
-       i = surf_usm_h%i(m) + surf_usm_h%ioff
-       j = surf_usm_h%j(m) + surf_usm_h%joff
-
-       nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ), DIM=1 )
-
-       IF ( buildings(nb)%on_pe )  THEN
-          buildings(nb)%m_h(n_fa(nb)) = m
-          n_fa(nb) = n_fa(nb) + 1
-       ENDIF
+    DO  l = 0, 1
+       DO  m = 1, surf_usm_h(l)%ns
+          i = surf_usm_h(l)%i(m) + surf_usm_h(l)%ioff
+          j = surf_usm_h(l)%j(m) + surf_usm_h(l)%joff
+
+          nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ), DIM=1 )
+
+          IF ( buildings(nb)%on_pe )  THEN
+             buildings(nb)%m_h(n_fa(nb)) = m
+             n_fa(nb) = n_fa(nb) + 1
+          ENDIF
+       ENDDO
     ENDDO
 
@@ -1212,9 +1219,10 @@
           DO  fa = 1, buildings(nb)%num_facades_per_building_h_l
 !
-!--          Determine index where corresponding surface-type information is stored.
-             m = buildings(nb)%m_h(fa)
+!--          Determine indices where corresponding surface-type information is stored.
+             l = buildings(nb)%l_v(fa)
+             m = buildings(nb)%m_v(fa)
 !
 !--          Determine building height level index.
-             kk = surf_usm_h%k(m) + surf_usm_h%koff
+             kk = surf_usm_h(l)%k(m) + surf_usm_h(l)%koff
 !
 !--          Building geometries --> not time-dependent
@@ -1225,5 +1233,5 @@
                                             ( buildings(nb)%num_facades_per_building_h +           &
                                               buildings(nb)%num_facades_per_building_v )              !< [m2] area of total facade
-             window_area_per_facade       = surf_usm_h%frac(m,ind_wat_win)  * facade_element_area     !< [m2] window area per facade
+             window_area_per_facade       = surf_usm_h(l)%frac(m,ind_wat_win)  * facade_element_area     !< [m2] window area per facade
                                                                                                       !< element
 
@@ -1274,14 +1282,14 @@
 !
 !--          Net short-wave radiation through window area (was i_global)
-             net_sw_in = surf_usm_h%rad_sw_in(m) - surf_usm_h%rad_sw_out(m)
+             net_sw_in = surf_usm_h(l)%rad_sw_in(m) - surf_usm_h(l)%rad_sw_out(m)
 !
 !--          Quantities needed for im_calc_temperatures
-             i = surf_usm_h%i(m)
-             j = surf_usm_h%j(m)
-             k = surf_usm_h%k(m)
-             near_facade_temperature = surf_usm_h%pt_10cm(m)
-             indoor_wall_window_temperature =                                                      &
-                                            surf_usm_h%frac(m,ind_veg_wall) * t_wall_h(nzt_wall,m) &
-                                          + surf_usm_h%frac(m,ind_wat_win)  * t_window_h(nzt_wall,m)
+             i = surf_usm_h(l)%i(m)
+             j = surf_usm_h(l)%j(m)
+             k = surf_usm_h(l)%k(m)
+             near_facade_temperature = surf_usm_h(l)%pt_10cm(m)
+             indoor_wall_window_temperature =                                                             &
+                                            surf_usm_h(l)%frac(m,ind_veg_wall) * t_wall_h(l)%val(nzt_wall,m) &
+                                          + surf_usm_h(l)%frac(m,ind_wat_win)  * t_window_h(l)%val(nzt_wall,m)
 !
 !--          Solar thermal gains. If net_sw_in larger than sun-protection threshold parameter
@@ -1393,5 +1401,5 @@
 !--          Will be used for thermal comfort calculations.
              theta_op     = 0.3_wp * theta_air_ac + 0.7_wp * theta_s          !< [degree_C] operative Temperature Eq. (C.12)
-!              surf_usm_h%t_indoor(m) = theta_op                               !< not integrated now
+!              surf_usm_h(l)%t_indoor(m) = theta_op                               !< not integrated now
 !
 !--          Heat flux into the wall. Value needed in urban_surface_mod to
@@ -1403,6 +1411,6 @@
 !
 !--          Transfer q_wall_win back to USM (innermost wall/window layer)
-             surf_usm_h%iwghf_eb(m)        = q_wall_win
-             surf_usm_h%iwghf_eb_window(m) = q_wall_win
+             surf_usm_h(l)%iwghf_eb(m)        = q_wall_win
+             surf_usm_h(l)%iwghf_eb_window(m) = q_wall_win
 !
 !--          Sum up operational indoor temperature per kk-level. Further below, this temperature is
@@ -1425,5 +1433,5 @@
                             ) / facade_element_area                                             !< [W/m2] , observe the directional
                                                                                                 !< convention in PALM!
-             surf_usm_h%waste_heat(m) = q_waste_heat
+             surf_usm_h(l)%waste_heat(m) = q_waste_heat
           ENDDO !< Horizontal surfaces loop
 !
@@ -1510,6 +1518,6 @@
              near_facade_temperature = surf_usm_v(l)%pt_10cm(m)
              indoor_wall_window_temperature =                                                      &
-                                    surf_usm_v(l)%frac(m,ind_veg_wall) * t_wall_v(l)%t(nzt_wall,m) &
-                                  + surf_usm_v(l)%frac(m,ind_wat_win)  * t_window_v(l)%t(nzt_wall,m)
+                                    surf_usm_v(l)%frac(m,ind_veg_wall) * t_wall_v(l)%val(nzt_wall,m) &
+                                  + surf_usm_v(l)%frac(m,ind_wat_win)  * t_window_v(l)%val(nzt_wall,m)
 !
 !--          Solar thermal gains. If net_sw_in larger than sun-protection
@@ -1885,9 +1893,9 @@
         CASE ( 'im_hf_roof' )
            IF ( av == 0 )  THEN
-              DO  m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m) !+ surf_usm_h%ioff
-                 j = surf_usm_h%j(m) !+ surf_usm_h%joff
-                 k = surf_usm_h%k(m) !+ surf_usm_h%koff
-                 local_pf(i,j,k) = surf_usm_h%iwghf_eb(m)
+              DO  m = 1, surf_usm_h(0)%ns
+                 i = surf_usm_h(0)%i(m) !+ surf_usm_h%ioff
+                 j = surf_usm_h(0)%j(m) !+ surf_usm_h%joff
+                 k = surf_usm_h(0)%k(m) !+ surf_usm_h%koff
+                 local_pf(i,j,k) = surf_usm_h(0)%iwghf_eb(m)
               ENDDO
            ENDIF
@@ -1895,9 +1903,9 @@
         CASE ( 'im_hf_roof_waste' )
            IF ( av == 0 )  THEN
-              DO m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m) !+ surf_usm_h%ioff
-                 j = surf_usm_h%j(m) !+ surf_usm_h%joff
-                 k = surf_usm_h%k(m) !+ surf_usm_h%koff
-                 local_pf(i,j,k) = surf_usm_h%waste_heat(m)
+              DO m = 1, surf_usm_h(0)%ns
+                 i = surf_usm_h(0)%i(m) !+ surf_usm_h%ioff
+                 j = surf_usm_h(0)%j(m) !+ surf_usm_h%joff
+                 k = surf_usm_h(0)%k(m) !+ surf_usm_h%koff
+                 local_pf(i,j,k) = surf_usm_h(0)%waste_heat(m)
               ENDDO
            ENDIF
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 4670)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 4671)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4648 2020-08-25 07:52:08Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -1631,6 +1634,6 @@
        IF ( use_surface_fluxes  .AND.  constant_heatflux  .AND.  random_heatflux )  THEN
           IF ( surf_def_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_def_h(0) )
-          IF ( surf_lsm_h%ns    >= 1 )  CALL disturb_heatflux( surf_lsm_h    )
-          IF ( surf_usm_h%ns    >= 1 )  CALL disturb_heatflux( surf_usm_h    )
+          IF ( surf_lsm_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_lsm_h(0) )
+          IF ( surf_usm_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_usm_h(0) )
        ENDIF
     ENDIF
@@ -1673,12 +1676,12 @@
                    mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + zw(k-1)
                 ENDIF
-                IF ( surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i) )  THEN
-                   m = surf_lsm_h%start_index(j,i)
-                   k = surf_lsm_h%k(m)
+                IF ( surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i) )  THEN
+                   m = surf_lsm_h(0)%start_index(j,i)
+                   k = surf_lsm_h(0)%k(m)
                    mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + zw(k-1)
                 ENDIF
-                IF ( surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i) )  THEN
-                   m = surf_usm_h%start_index(j,i)
-                   k = surf_usm_h%k(m)
+                IF ( surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i) )  THEN
+                   m = surf_usm_h(0)%start_index(j,i)
+                   k = surf_usm_h(0)%k(m)
                    mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + zw(k-1)
                 ENDIF
Index: palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4671)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4648 2020-08-25 07:52:08Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -1055,5 +1058,5 @@
 !--    exact for heterogeneous z0.
 !--    However, sensitivity studies showed that the effect is negligible.
-       z0_av_local  = SUM( surf_def_h(0)%z0 ) + SUM( surf_lsm_h%z0 ) + SUM( surf_usm_h%z0 )
+       z0_av_local  = SUM( surf_def_h(0)%z0 ) + SUM( surf_lsm_h(0)%z0 ) + SUM( surf_usm_h(0)%z0 )
        z0_av_global = 0.0_wp
 
